# coding: utf-8

"""
    API Alegra Proveedor Electrónico Colombia

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from typing import Optional, Set
from typing_extensions import Self

class CreateSupportDocumentRequestDocumentCurrency(BaseModel):
    """
    La divisa aplicable al documento soporte debe enviarse a través de este objeto. Si no se incluye, se utilizará COP (Peso Colombiano) como moneda predeterminada.
    """ # noqa: E501
    code: StrictStr = Field(description="Código de moneda de la transacción. Ver el listado disponible en la tabla DIAN - Monedas (`currencies`)  Esta moneda se aplica a todo el documento. <br><i>Campo oficial DIAN &lt;@currencyID&gt;</i>")
    rate_value: Union[StrictFloat, StrictInt] = Field(description="Valor de la tasa de cambio de la moneda utilizada en el documento en el campo 'currencyCode' a Pesos Colombianos. <br><i>Campo oficial DIAN &lt;CalculationRate&gt;</i>", alias="rateValue")
    rate_date: date = Field(description="Fecha en la que se fijó o acordó la tasa de cambio. <br><i>Campo oficial DIAN &lt;Date&gt;</i>", alias="rateDate")
    __properties: ClassVar[List[str]] = ["code", "rateValue", "rateDate"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateSupportDocumentRequestDocumentCurrency from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateSupportDocumentRequestDocumentCurrency from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "code": obj.get("code"),
            "rateValue": obj.get("rateValue"),
            "rateDate": obj.get("rateDate")
        })
        return _obj


