# coding: utf-8

"""
    API Alegra Proveedor Electrónico Colombia

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateSupportDocumentRequestItemsInnerStandardCode(BaseModel):
    """
    Este grupo de datos se utiliza para identificar el artículo o servicio de acuerdo con un estándar establecido. <br><i>Grupo de información oficial DIAN &lt;StandardItemIdentification&gt;</i>
    """ # noqa: E501
    identification_id: StrictStr = Field(description="Código de artículo de acuerdo al estándar utilizado. <br><i>Campo oficial DIAN &lt;ID&gt;</i>", alias="identificationId")
    id: Optional[StrictStr] = Field(default=None, description="Código del estándar. Deberá contener uno de los siguientes valores posibles de acuerdo al código utilizado para identificar el ítem en el elemento `identificationId`:`001`: UNSPSC-Colombia Compra Eficiente; `010` GTIN-Números Globales de Identificación de Productos – GTIN; `020` Partida arancelaria según estatus tributario;`999` Estándar de adopción del contribuyente. <br><i>Campo oficial DIAN &lt;schemeID&gt;</i>")
    __properties: ClassVar[List[str]] = ["identificationId", "id"]

    @field_validator('id')
    def id_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['001', '010', '020', '999']):
            raise ValueError("must be one of enum values ('001', '010', '020', '999')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateSupportDocumentRequestItemsInnerStandardCode from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateSupportDocumentRequestItemsInnerStandardCode from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "identificationId": obj.get("identificationId"),
            "id": obj.get("id")
        })
        return _obj


